#Agent.py
from Tools import *

class Agent:
    def __init__(self, number,myWorldState,
                 xPos, yPos, lX =-20,rX=19, lY=-20,rY=19, agType=""):
        # the environment
        self.agOperatingSets=[]
        self.number = number
        self.lX = lX
        self.rX = rX
        self.lY = lY
        self.rY = rY
        self.myWorldState = myWorldState
        self.agType=agType
        # the agent
        self.xPos = xPos
        self.yPos = yPos
        print "agent", self.agType, "#", self.number, \
     	      "has been created at", self.xPos, ",", self.yPos

    # add operating an set
    def setAnOperatingSet(self,aSet):
        self.agOperatingSets.append(aSet)

    # get operating set list
    def getOperatingSetList(self):
        return self.agOperatingSets

    # reset values
    def setNewCycleValues(self):
        pass # here is only reported for future uses

    # ",**d" in the parameter lists of the methods is a place holder
    # in case we use, calling the method, a dictionary as last par

    # eating (to be developed)
    def eat(self,**d):
        print "I'm %s agent # %d: " % (self.agType,self.number),
        print "nothing to eat here!"

    # dancing
    def dance(self,**d):
        print "I'm %s agent # %d: " % (self.agType,self.number),
        print "it's not time to dance!"

    # the action, also jumping
    def randomMovement(self,**k):
        if random.random()<=self.myWorldState.getGeneralMovingProb():
            print "agent %s # %d moving" % (self.agType,self.number)
            self.jump=k["jump"]
            dx=randomMove(self.jump)
            self.xPos +=dx
            dy=randomMove(self.jump)
            self.yPos += dy
            #self.xPos = (self.xPos + self.worldXSize) % self.worldXSize
            #self.yPos = (self.yPos + self.worldYSize) % self.worldYSize
            if self.xPos < self.lX : self.xPos=self.lX
            if self.xPos > self.rX : self.xPos=self.rX
            if self.yPos < self.lY : self.yPos=self.lY
            if self.yPos > self.rY : self.yPos=self.rY

            if abs(dx) > 4 and abs(dy) > 4 :
    
            # modify actionGroup "move"
                actionGroup=actionDictionary.get("move","none")
                                    # in case, return "none"
        
                if actionGroup=="none": print "warning, actionGroup not found "+\
                                "in agent "+ str(self.number)
            
                else: actionGroup.setLocalCode(actionGroup.getLocalCode()+\
                                "print 'agent %s # %d made a big jump';" \
                                               % (self.agType,self.number))

    # report
    def reportPosition(self,**d):
        print self.agType, "agent # ", self.number, " is at X = ", \
               self.xPos, " Y = ", self.yPos

    # methods for Tk graphic applications
    def getXPos(self):
        return self.xPos

    def getYPos(self):
        return self.yPos

    def setGraphicItem(self, grI):
        self.graphicItem=grI

    def getGraphicItem(self):
        return self.graphicItem

    def getAgType(self):
        return self.agType

# returns -1, 0, 1  with equal probability
def randomMove(jump):
    return random.randint(-1, 1)*jump
